/**
 * 
 */
package library;

import java.util.Vector;

import javax.swing.JLabel;
import javax.swing.table.AbstractTableModel;

/**
 * @author fiinmani
 *
 */
class ColumnData
{
  public String  title;
  public int     width;
  public int     alignment;

  public ColumnData(String aTitle, int aWidth, int aAlignment) {
    title = aTitle;
    width = aWidth;
    alignment = aAlignment;
  }
}

/**
 * @author fiinmani
 *
 */
public class LibraryBookModel extends AbstractTableModel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Vector<Book> result;

	static final public ColumnData columns[] = {
	    new ColumnData( Text.bookTablefieldNames[0], Text.bookTableFieldLengths[0], JLabel.LEFT ),
	    new ColumnData( Text.bookTablefieldNames[1], Text.bookTableFieldLengths[1], JLabel.LEFT ),
	    new ColumnData( Text.bookTablefieldNames[2], Text.bookTableFieldLengths[2], JLabel.LEFT ),
	    new ColumnData( Text.bookTablefieldNames[3], Text.bookTableFieldLengths[3], JLabel.CENTER ),
	    new ColumnData( Text.bookTablefieldNames[4], Text.bookTableFieldLengths[4], JLabel.CENTER ),
	    new ColumnData( Text.bookTablefieldNames[5], Text.bookTableFieldLengths[5], JLabel.LEFT ),
	    new ColumnData( Text.bookTablefieldNames[6], Text.bookTableFieldLengths[6], JLabel.CENTER ),
	    new ColumnData( Text.bookTablefieldNames[7], Text.bookTableFieldLengths[7], JLabel.LEFT )
	  };

	public LibraryBookModel(Vector<Book> aResult) {
		
		result = aResult;
	}

	/**
	 * 
	 */
	public int getColumnCount() {
		return columns.length;
	}

	/**
	 * 
	 */
	public int getRowCount() {
		return result==null ? 0 : result.size();
	}

	/**
	 * 
	 */
	public Object getValueAt(int nRow, int nCol) {
	    if (nRow < 0 || nRow>=getRowCount())
	        return "";
	    Book row = (Book)result.elementAt(nRow);
	      switch (nCol) {
	        case 0: return row.surname;
	        case 1: return row.forename;
	        case 2: return row.bookname;
	        case 3: return row.pubyear;
	        case 4: return row.isbn;
	        case 5: return row.orgname;
	        case 6: return row.orgyear;
	        case 7: return row.other;
	      }
	      return "";
	}
	
    /**
	 * 
	 */
	public boolean isCellEditable(int nRow, int nCol) {
		return false;
	}

	/**
	 * 
	 */
	public Book getRowAt(int nRow) {
		return (Book)result.elementAt(nRow);
	}

}
