package library;

import java.util.Vector;

import javax.swing.JLabel;
import javax.swing.table.AbstractTableModel;

public class LibraryDvdModel extends AbstractTableModel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Vector<Dvd> result;

	static final public ColumnData columns[] = {
	    new ColumnData( Text.dvdTablefieldNames[0], Text.dvdTableFieldLengths[0], JLabel.LEFT ),
	    new ColumnData( Text.dvdTablefieldNames[1], Text.dvdTableFieldLengths[1], JLabel.LEFT ),
	    new ColumnData( Text.dvdTablefieldNames[2], Text.dvdTableFieldLengths[2], JLabel.LEFT ),
	    new ColumnData( Text.dvdTablefieldNames[3], Text.dvdTableFieldLengths[3], JLabel.LEFT ),
	    new ColumnData( Text.dvdTablefieldNames[4], Text.dvdTableFieldLengths[4], JLabel.LEFT ),
	    new ColumnData( Text.dvdTablefieldNames[5], Text.dvdTableFieldLengths[5], JLabel.LEFT ),
	    new ColumnData( Text.dvdTablefieldNames[6], Text.dvdTableFieldLengths[6], JLabel.LEFT )
	  };

	public LibraryDvdModel(Vector<Dvd> aResult) {
		
		result = aResult;
	}

	@Override
	public int getColumnCount() {
		return columns.length;	}

	@Override
	public int getRowCount() {
		return result==null ? 0 : result.size();
	}

	@Override
	public Object getValueAt(int nRow, int nCol) {
	    if (nRow < 0 || nRow>=getRowCount())
	        return "";
	    Dvd row = (Dvd)result.elementAt(nRow);
	      switch (nCol) {
	        case 0: return row.name;
	        case 1: return row.year;
	        case 2: return row.orgname;
	        case 3: return row.barcode;
	        case 4: return row.director;
	        case 5: return row.music;
	        case 6: return row.other;
	      }
	      return "";
	}

    /**
	 * 
	 */
	public boolean isCellEditable(int nRow, int nCol) {
		return false;
	}

	/**
	 * 
	 */
	public Dvd getRowAt(int nRow) {
		return (Dvd)result.elementAt(nRow);
	}

}
