/**
 * 
 */
package library;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

/**
 * @author fiinmani
 *
 */
public class MainWindow implements ActionListener, DocumentListener, WindowListener {
	private Utils utils;
	private JFrame mainFrame;
	
	/*
	 * 
	 */
	public MainWindow(Utils aUtils) {
		utils = aUtils;
		}

	public void Show() {

		utils.CreateLibrary();

		mainFrame = new JFrame(Text.mainCaptionText);
		mainFrame.setLayout(new BorderLayout());	
		mainFrame.setResizable(false);
		
		
		utils.CreateTopPanel(mainFrame, this);
		mainFrame.add(utils.GetTopPanel(), BorderLayout.NORTH);

		utils.CreateCenterPanel(mainFrame,this);
		mainFrame.add(utils.GetCenterPanel(), BorderLayout.CENTER);

		utils.CreateBottomPanel(Text.bookcount + utils.GetBookCount());
		mainFrame.add(utils.GetBottomPanel(), BorderLayout.SOUTH);

		mainFrame.setLocation(200, 200);
		mainFrame.pack();
		mainFrame.setVisible(true);

		utils.SetFrame(mainFrame);
		
	}

	/*
	 * 
	 */
	public void actionPerformed(ActionEvent event) {
		
		String command = event.getActionCommand();

		if (command == Text.exportCommand) {
			utils.Export(mainFrame);
		} else if (command == Text.importCommand) {
			utils.Import(mainFrame);
		} else if (command == Text.addbookCommand) {
			utils.CreateAddBookForm();
		} else if (command == Text.modifybookCommand) {
			utils.ModifyBook();
		} else if (command == Text.adddvdCommand) {
			utils.CreateAddDvdForm();
		} else if (command == Text.removebookCommand) {
			boolean result = utils.RemoveBook(mainFrame);
			if(true==result) {
				utils.UpdateCenterPanel();
			}
		} else if (command == Text.removedvdCommand) {
			boolean result = utils.RemoveDvd(mainFrame);
			if(true==result) {
				utils.UpdateCenterPanel();
			}
		} else if (command == Text.printCommand) {
			utils.Print();
		} else if (command == Text.exitCommand) {
			utils.Exit(mainFrame);
		}
	}

	@Override	public void changedUpdate(DocumentEvent event) {
		// TODO Auto-generated method stub
		
	}

	/*
	 * 
	 */
	public void insertUpdate(DocumentEvent event) {
		utils.UpdateCenterPanel();
	}

	/*
	 * 
	 */
	public void removeUpdate(DocumentEvent event) {
		utils.UpdateCenterPanel();
	}

	@Override
	public void windowActivated(WindowEvent event) {
	}

	@Override
	public void windowClosed(WindowEvent event) {
	}

	@Override
	public void windowClosing(WindowEvent event) {
		utils.Exit(mainFrame);
	}

	@Override
	public void windowDeactivated(WindowEvent event) {
	}

	@Override
	public void windowDeiconified(WindowEvent event) {
	}

	@Override
	public void windowIconified(WindowEvent event) {
	}

	@Override
	public void windowOpened(WindowEvent event) {
	}

}
