/**
 * 
 */
package library;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableColumn;

/**
 * @author fiinmani
 *
 */
public class Utils {
	Object[] options = {"Kyllä","Ei"};
	private SqlHandler sql;
	private XmlHandler xml;
	private Font font;
	private int bookFieldTotalLength = 0;
	private int dvdFieldTotalLength = 0;
	private LibraryBookModel bookModel;
	private LibraryDvdModel dvdModel;
	private int curRowIndex = 0;
	private int paneIndex = 0;
	private JScrollPane dvdTableScrollPane,bookTableScrollPane;
	private JTextField searchfield;
	private JPanel topPanel,bottomPanel;
	private JTabbedPane centerPanel;
	private JFrame addFrame;
	private JFrame mainFrame;
	private JTextField[] fields;
	private JTextArea textArea;
	private Book selectedbook;	
	private JPopupMenu aPopupMenu;
	private MainWindow window;
	private JPopupMenu popupMenu;
	
	/*
	 * Utils
	 */
	public Utils(SqlHandler sqlHandle, XmlHandler xmlHandle) {
		sql = sqlHandle;
		xml = xmlHandle;
        
		for (int j = 0; j < Text.bookTablefieldNames.length; j++) {
        	bookFieldTotalLength += Text.bookTableFieldLengths[j];
        }
		       
		for (int j = 0; j < Text.dvdTablefieldNames.length; j++) {
        	dvdFieldTotalLength += Text.dvdTableFieldLengths[j];
        }
		
 		font = new Font("Dialog", Font.PLAIN, 12);
	}

	/*
	 * SetFrame
	 * 
	 * Tuodaan pääikkuna
	 * 
	 */
//	public void SetFrame(JFrame aFrame) {
//		mainFrame = aFrame;
//		bookUI.SetFrame(mainFrame);
//	}
	 
	/*
	 * CreateLibrary
	 */
	@SuppressWarnings("unchecked")
	public void CreateLibrary() {
	
		Object[] library = { new Vector<Book>(), new Vector<Dvd>()};
		
		library = sql.GetLibrary();

		CreateBookModel((Vector<Book>) library[0]);
		CreateDvdModel((Vector<Dvd>) library[1]);
		
		//bookUI = new BookUI();
 		//SetBookfieldLength(bookFieldTotalLength);
	}
	
	/*
	 * CreateBookModel
	 */
	public void CreateBookModel(Vector<Book> aModel) {

		bookModel = new LibraryBookModel(aModel);
		System.out.println("CreateBookModel: Returned book count is : " + GetBookCount());
		CreateBookScrollPane(bookModel);
	}

	/*
	 * §
	 */
	public void UpdateBookLibrary(String aQueryString) {
		
		Vector<Book> result = new Vector<Book>();
		result = sql.GetBooks(aQueryString);
		CreateBookModel(result);
	}

	/*
	 * UpdateDvdLibrary
	 */
	public void UpdateDvdLibrary(String aQueryString) {
		
		Vector<Dvd> result = new Vector<Dvd>();
		result = sql.GetDvds(aQueryString);
		CreateDvdModel(result);
	}

	

	/*
	 * CreateDvdModel
	 */
	public void CreateDvdModel(Vector<Dvd> aModel) {
	
		dvdModel = new LibraryDvdModel(aModel);
		System.out.println("CreateDvdModel: Returned DVD count is : " + GetDvdCount());
		CreateDvdScrollPane(dvdModel);
	}

	/*
	 * CreateDvdScrollPane
	 * 
	 * Luodaan taulukko joka sisältää DVD:t
	 * 
	 */
	private void CreateDvdScrollPane(LibraryDvdModel model) {

		final JTable table = new JTable();
	    table.setPreferredScrollableViewportSize(new Dimension(dvdFieldTotalLength,Text.tableHeight));
        table.setFillsViewportHeight(true);
        table.setAutoCreateRowSorter(true);
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		table.setAutoCreateColumnsFromModel(false);
		table.setModel(model);
		for (int k = 0; k < LibraryDvdModel.columns.length; k++) {
			TableRenderer renderer = new TableRenderer();
		    renderer.setHorizontalAlignment(LibraryDvdModel.columns[k].alignment);
		    TableColumn column = new TableColumn(k, LibraryDvdModel.columns[k].width, renderer, null);
		    column.setHeaderValue(LibraryDvdModel.columns[k].title);
		    table.addColumn(column);   
		}
		table.setDefaultRenderer(Dvd.class, new TableRenderer());
		ListSelectionModel listSelectionModel = table.getSelectionModel();
		ListSelectionListener selectionListener = new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent event) {
					curRowIndex = table.getSelectedRow();
				}
		};
		listSelectionModel.addListSelectionListener(selectionListener);
		table.setSelectionModel(listSelectionModel);
		dvdTableScrollPane = new JScrollPane(table);	
	}

	/*
	 * CreateTopPanel
	 * 
	 * Luodaan yläpaneeli jossa on painikkeet toiminnoille sekä haku-kenttä
	 * 
	 */
	public void CreateTopPanel(final JFrame aFrame, final MainWindow mainWindow) {
		
		JPanel buttonPanel = null, searchPanel = null;
		JLabel searchLabel = null;
		
		topPanel = new JPanel(new BorderLayout());
		buttonPanel = new JPanel();
		buttonPanel.setBorder(BorderFactory.createRaisedBevelBorder());		
		searchPanel = new JPanel(new BorderLayout());
		searchPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		JPanel labelPanel = new JPanel(new GridLayout(1, 1));
		JPanel fieldPanel = new JPanel(new GridLayout(1, 1));
		searchPanel.add(labelPanel, BorderLayout.WEST);
		searchPanel.add(fieldPanel, BorderLayout.CENTER);
		searchfield = new JTextField();
		searchfield.addActionListener(mainWindow);
		searchfield.getDocument().addDocumentListener(mainWindow);
		searchfield.setColumns(30);
		JPanel p = new JPanel(new FlowLayout(FlowLayout.LEFT));
		p.add(searchfield);
		fieldPanel.add(p);

		switch(paneIndex) {
			case 0:  {
				JButton[] button = new JButton[Text.bookbuttonText.length];
				for (int i = 0; i < Text.bookbuttonText.length; i++) {	
					button[i] = new JButton(Text.bookbuttonText[i]);
					button[i].setActionCommand(Text.bookbuttonCommand[i]);
					button[i].addActionListener(mainWindow);
					buttonPanel.add(button[i]);
				}
				
				searchLabel = new JLabel(Text.searchbookText, JLabel.RIGHT);
				break;
			}
			case 1: {
				JButton[] button = new JButton[Text.dvdbuttonText.length];
				for (int i = 0; i < Text.dvdbuttonText.length; i++) {	
					button[i] = new JButton(Text.dvdbuttonText[i]);
					button[i].setActionCommand(Text.dvdbuttonCommand[i]);
					button[i].addActionListener(mainWindow);
					buttonPanel.add(button[i]);
				}
				
				searchLabel = new JLabel(Text.searchdvdText, JLabel.RIGHT);
				break;
			}
		}

		searchLabel.setFont(font);
		searchLabel.setLabelFor(searchfield);
		labelPanel.add(searchLabel);

		topPanel.add(buttonPanel, BorderLayout.NORTH);
		topPanel.add(searchPanel, BorderLayout.SOUTH);
		topPanel.setBorder(BorderFactory.createEmptyBorder());
	}

	/*
	 * CreateCenterPanel
	 */
	public void CreateCenterPanel(final JFrame aFrame, final MainWindow mainWindow) {
		
		//window = mainWindow;
		centerPanel = new JTabbedPane();
		centerPanel.addTab(Text.bookTabPaneText, null, null, null);
		centerPanel.addTab(Text.dvdTabPaneText, null, null, null);

		ChangeListener tabListener = new ChangeListener() {
			public void stateChanged(ChangeEvent changeEvent) {
				JTabbedPane sourceTabbedPane = (JTabbedPane) changeEvent.getSource();
				paneIndex = sourceTabbedPane.getSelectedIndex();
				UpdateTopPanel(aFrame, mainWindow);
				UpdateBottomPanel();
			}
		};
			 
		centerPanel.addChangeListener(tabListener);
	}
	
	public void UpdateCenterPanel() {
		String search_string = null;
			
		mainFrame.remove(GetBottomPanel());

		switch(paneIndex) {
		case 0:  {
			search_string = Text.GET_BOOK;
			search_string += Text.WHERE;
			search_string += Text.bookDatafieldNames[0] + " LIKE '%" + GetSearchText() + "%'";
			
			for (int i = 1; i < Text.bookDatafieldNames.length; i += 1) {
				search_string += " OR ";
				search_string += Text.bookDatafieldNames[i] + " LIKE '%" + GetSearchText() + "%'";
			}	

			UpdateBookLibrary(search_string);
			UpdateBottomPanel();
			break;
			}
		case 1: {
			search_string = Text.GET_DVD;
			search_string += Text.WHERE;
			search_string += Text.dvdDatafieldNames[0] + " LIKE '%" + GetSearchText() + "%'";
			
			for (int i = 1; i < Text.dvdDatafieldNames.length; i += 1) {
				search_string += " OR ";
				search_string += Text.dvdDatafieldNames[i] + " LIKE '%" + GetSearchText() + "%'";
			}

			UpdateDvdLibrary(search_string);
			UpdateBottomPanel();
			
			break;
			}
		}
		mainFrame.add(GetBottomPanel(), BorderLayout.SOUTH);
		mainFrame.pack();
		mainFrame.validate();
		mainFrame.repaint();
	}

	public void UpdateBottomPanel() {
		
		mainFrame.remove(GetBottomPanel());

		switch(paneIndex) {
		case 0:  {
			CreateBottomPanel(Text.bookcount + GetBookCount());
			break;
			}
		case 1: {
			CreateBottomPanel(Text.dvdcount + GetDvdCount());		
			break;
			}
		
		}
		mainFrame.add(GetBottomPanel(), BorderLayout.SOUTH);
		mainFrame.pack();
		mainFrame.validate();
		mainFrame.repaint();
		}

	
	/*
	 * AddDvd
	 */
	public void AddDvd() {
		int pubdate;
		boolean addResult = false;
		String[] fieldValue;
		String otherValue;
		
		try {	
			fieldValue = new String[LibraryDvdModel.columns.length];
			fieldValue = GetDvdAddFields();
			otherValue = GetOtherField();
			
			if (fieldValue[1].length() == 0) {
				pubdate = 0;
			} else {
				pubdate = Integer.parseInt(fieldValue[1]);
			}
			
			Dvd dvd = new Dvd(fieldValue[0],
							   pubdate,
							   fieldValue[2],
							   fieldValue[3],
							   fieldValue[4],
							   fieldValue[5],
							   otherValue);

			addResult  = sql.AddDvd(dvd);

			if(addResult != false) {
				JOptionPane.showMessageDialog(addFrame, Text.adddvdsuccess, Text.addtitle, JOptionPane.INFORMATION_MESSAGE);
				} else {
				JOptionPane.showMessageDialog(addFrame, Text.adddvdfail, Text.addtitle, JOptionPane.ERROR_MESSAGE);
			}

			//SetDvdAddFormFields("");
		} catch(NumberFormatException e) { 
			JOptionPane.showMessageDialog(addFrame, Text.intfail, Text.addtitle, JOptionPane.ERROR_MESSAGE); 
		} 
	}

	/*
	 * CreateBottomPanel
	 * 
	 * Luodaan alapaneli jossa näytetään kirjojen tai DVD:n määrä kirjastossa
	 * 
	 */
	public void CreateBottomPanel(String aString) {
		
		bottomPanel = new JPanel(new BorderLayout());
		JPanel textPanel = new JPanel(new GridLayout(1, 1));
		JLabel label = new JLabel(aString, JLabel.LEFT);
	
		label.setFont(font);
		textPanel.add(label);

		switch(paneIndex) {
			case 0:  {
				bottomPanel.add(GetBookScrollPane(), BorderLayout.NORTH);
				CreateDvdModel(sql.GetDvds(Text.GET_DVD+Text.ORDER_DVD));
				break;
				}
			case 1: {
				bottomPanel.add(GetDvdScrollPane(), BorderLayout.NORTH);
				CreateBookModel(sql.GetBooks(Text.GET_BOOK+Text.ORDER_BOOK));
				break;
				}
		}
		bottomPanel.add(textPanel, BorderLayout.SOUTH);
	}

	/*
	 * UpdateTopPanel
	 */
	public void UpdateTopPanel(JFrame aFrame, MainWindow mainWindow) {
		
		aFrame.remove(GetTopPanel());
		CreateTopPanel(aFrame,mainWindow);
		aFrame.add(GetTopPanel(), BorderLayout.NORTH);
		aFrame.validate();
		aFrame.repaint();
	}




	/*
	 * Export
	 * 
	 * Viedään kirjaston kirjat ja DVD:t XML-tiedostoon
	 * 
	 */
	public void Export(JFrame aFrame) {
		boolean save = false;
		
		Vector<Book> bookResult = new Vector<Book>();
		bookResult = sql.GetBooks(Text.GET_BOOK+Text.ORDER_BOOK);
		LibraryBookModel bookModel = new LibraryBookModel(bookResult);		
		Vector<Dvd> dvdResult = new Vector<Dvd>();
		dvdResult = sql.GetDvds(Text.GET_DVD+Text.ORDER_DVD);
		LibraryDvdModel dvdModel = new LibraryDvdModel(dvdResult);		
		
		JFileChooser exportFile = new JFileChooser();
		exportFile.setCurrentDirectory(new File("."));
		exportFile.setDialogTitle(Text.exportText);
		exportFile.setAcceptAllFileFilterUsed(false);
		exportFile.addChoosableFileFilter(new XmlFilter());
		int tulos = exportFile.showSaveDialog(aFrame);
		if (tulos == JFileChooser.CANCEL_OPTION) {
			CreateMessageDialog(aFrame,Text.exportcancel,Text.exportText,JOptionPane.INFORMATION_MESSAGE);
		} else if (tulos == JFileChooser.APPROVE_OPTION) {
			File xmlFile = exportFile.getSelectedFile();
			
			// Tarkistetetaan onko XML-tiedosto jo olemassa
			if(true == xmlFile.exists()) {
				
				int overwrite = CreateOptionDialog(aFrame, Text.fileoverwrite, Text.exportText);

				if(JOptionPane.NO_OPTION == overwrite) {
					CreateMessageDialog(aFrame,Text.exportcancel,Text.exportText,JOptionPane.INFORMATION_MESSAGE);
				} else if(JOptionPane.YES_OPTION == overwrite) {
					save = true;
				}

			} else if (false == xmlFile.exists()) {
				save = true;
			}
			
			if (true == save) {
				try {
					xml.Export(bookModel,dvdModel,xmlFile.toString());
					CreateMessageDialog(aFrame,Text.exportsuccess,Text.exportText,JOptionPane.INFORMATION_MESSAGE);
				} catch (Exception e) {
					CreateMessageDialog(aFrame,Text.exportfail,Text.exportText,JOptionPane.ERROR_MESSAGE);
				}
			}
		}
	}

	/*
	 * Import
	 * 
	 * Tuodaan kirjaston kirjat ja DVD:t XML-tiedostosta
	 * 
	 */
	public void Import(JFrame aFrame) {

		JFileChooser importFile = new JFileChooser();
		importFile.setCurrentDirectory(new File("."));
		importFile.setDialogTitle(Text.exportText);
		importFile.setAcceptAllFileFilterUsed(false);
		importFile.addChoosableFileFilter(new XmlFilter());
		int tulos = importFile.showOpenDialog(aFrame);
		
		if (tulos == JFileChooser.CANCEL_OPTION) {
			CreateMessageDialog(aFrame,Text.importcancel,Text.importText,JOptionPane.INFORMATION_MESSAGE);
		} else if (tulos == JFileChooser.APPROVE_OPTION) {
			try {
				File xmlFile = importFile.getSelectedFile();
				sql.DeleteDatabase();
				sql.CreateDatabase();
				xml.Import(this,xmlFile.toString());
							    
				UpdateCenterPanel(); 
				CreateMessageDialog(aFrame,Text.importsuccess,Text.importText,JOptionPane.INFORMATION_MESSAGE);
			} catch (Exception e) {
				CreateMessageDialog(aFrame,Text.importfail,Text.importText,JOptionPane.ERROR_MESSAGE);
			}
		}
	}

	/*
	 * CreateAddBookForm
	 * 
	 * Luodaan kirjan lisäys -ikkuna
	 * 
	 */
	public void CreateAddBookForm() {
		
		JPanel formPanel, labelPanel, fieldPanel,buttonPanel;
		JScrollPane areaScrollPane;
		JButton add_button,exit_button;
		
		addFrame = new JFrame(Text.addbookText);
		addFrame.setLayout(new BorderLayout());

		// Luodaan kirjan tietojen sy�tt�kent�t ja otsakkeet 
		formPanel = new JPanel(new BorderLayout());
		labelPanel = new JPanel(new GridLayout(Text.bookTablefieldNames.length-1, 1));
		fieldPanel = new JPanel(new GridLayout(Text.bookTablefieldNames.length-1, 1));

		formPanel.add(labelPanel, BorderLayout.WEST);
		formPanel.add(fieldPanel, BorderLayout.CENTER);

		fields = new JTextField[Text.bookTablefieldNames.length-1];

		for (int i = 0; i < Text.bookTablefieldNames.length-1; i++) {
			JLabel lab;
			JPanel p;
			
			fields[i] = new JTextField();
			//fields[i].addActionListener(mainWindow);
			if (i < Text.bookTablefieldNames.length-1)
				fields[i].setColumns(30);

			lab = new JLabel(Text.bookTablefieldNames[i], JLabel.RIGHT);
			lab.setLabelFor(fields[i]);

			labelPanel.add(lab);
			p = new JPanel(new FlowLayout(FlowLayout.LEFT));
			p.add(fields[i]);
			fieldPanel.add(p);
		}

		// Luodaan muuta tietoa tekstikentt�
		textArea = new JTextArea();
		textArea.setLineWrap(true);
		textArea.setWrapStyleWord(true);
		areaScrollPane = new JScrollPane(textArea);
		areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		areaScrollPane.setPreferredSize(new Dimension(250, 100));
		areaScrollPane.setBorder(BorderFactory.createCompoundBorder(
				BorderFactory.createCompoundBorder(BorderFactory
						.createTitledBorder(Text.bookTablefieldNames[7]), BorderFactory
						.createEmptyBorder(5, 5, 5, 5)), areaScrollPane
						.getBorder()));

		addFrame.add(formPanel, BorderLayout.NORTH);
		addFrame.add(areaScrollPane, BorderLayout.CENTER);

		// Luodaan painonapit
		buttonPanel = new JPanel();

		add_button = new JButton(Text.addbookText);
		add_button.setActionCommand(Text.addbookFormCommand);
		add_button.addActionListener(new ActionListener() {
			 public void actionPerformed(ActionEvent e) {
				 AddBook();
			 }
		});		
		buttonPanel.add(add_button);
		exit_button = new JButton(Text.exitText);
		exit_button.setActionCommand(Text.exitFormCommand);
		exit_button.addActionListener(new ActionListener() {
			 public void actionPerformed(ActionEvent e) {
				addFrame.setVisible(false);
				addFrame.dispose();
				UpdateCenterPanel();
			 }
		});		
		buttonPanel.add(exit_button);
		addFrame.add(buttonPanel, BorderLayout.SOUTH);

		addFrame.setLocation(200, 200);
		addFrame.pack();
		addFrame.setVisible(true);
	}

	
	

	/*
	 * AddBook
	 */
	public void AddBook() {
		int pubyear,orgyear;
		boolean addResult = false;
		String[] fieldValue;
		String otherValue;
		
		try {	
			fieldValue = new String[LibraryBookModel.columns.length];
			fieldValue = GetBookAddFields();
			otherValue = GetOtherField();
			
			if (fieldValue[3].length() == 0) {
				pubyear = 0;
			} else {
				pubyear = Integer.parseInt(fieldValue[3]);
			}
			if (fieldValue[6].length() == 0) {
				orgyear = 0;
			} else {
				orgyear = Integer.parseInt(fieldValue[6]);
			}
			
			Book book = new Book(fieldValue[0],
						fieldValue[1],
						fieldValue[2],
						pubyear,
						fieldValue[4],
						fieldValue[5],
						orgyear,
						otherValue);

			addResult  = sql.AddBook(book);

			if(addResult != false) {
				JOptionPane.showMessageDialog(addFrame, Text.addbooksuccess, Text.addtitle, JOptionPane.INFORMATION_MESSAGE);
				} else {
				JOptionPane.showMessageDialog(addFrame, Text.addbookfail, Text.addtitle, JOptionPane.ERROR_MESSAGE);
			}

			//SetBookAddFormFields("");
		} catch(NumberFormatException e) { 
			JOptionPane.showMessageDialog(addFrame, Text.intfail, Text.addtitle, JOptionPane.ERROR_MESSAGE); 
		} 
	}

	
			
	/*
	 * CreateAddDvdForm
	 * 
	 * Luodaan DVD:n lisäys -ikkuna
	 * 
	 */
	public void CreateAddDvdForm() {
		
		JPanel formPanel, labelPanel, fieldPanel,buttonPanel;
		JScrollPane areaScrollPane;
		JButton add_button,exit_button;
		
		addFrame = new JFrame(Text.adddvdText);
		addFrame.setLayout(new BorderLayout());

		// Luodaan kirjan tietojen sy�tt�kent�t ja otsakkeet 
		formPanel = new JPanel(new BorderLayout());
		labelPanel = new JPanel(new GridLayout(Text.dvdTablefieldNames.length-1, 1));
		fieldPanel = new JPanel(new GridLayout(Text.dvdTablefieldNames.length-1, 1));

		formPanel.add(labelPanel, BorderLayout.WEST);
		formPanel.add(fieldPanel, BorderLayout.CENTER);

		fields = new JTextField[Text.dvdTablefieldNames.length-1];

		for (int i = 0; i < Text.dvdTablefieldNames.length-1; i++) {
			JLabel lab;
			JPanel p;
			
			fields[i] = new JTextField();
			if (i < Text.dvdTablefieldNames.length-1)
				fields[i].setColumns(30);

			lab = new JLabel(Text.dvdTablefieldNames[i], JLabel.RIGHT);
			lab.setLabelFor(fields[i]);

			labelPanel.add(lab);
			p = new JPanel(new FlowLayout(FlowLayout.LEFT));
			p.add(fields[i]);
			fieldPanel.add(p);
		}

		// Luodaan muuta tietoa tekstikentt�
		textArea = new JTextArea();
		textArea.setLineWrap(true);
		textArea.setWrapStyleWord(true);
		areaScrollPane = new JScrollPane(textArea);
		areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		areaScrollPane.setPreferredSize(new Dimension(250, 100));
		areaScrollPane.setBorder(BorderFactory.createCompoundBorder(
				BorderFactory.createCompoundBorder(BorderFactory
						.createTitledBorder(Text.dvdTablefieldNames[6]), BorderFactory
						.createEmptyBorder(5, 5, 5, 5)), areaScrollPane
						.getBorder()));

		addFrame.add(formPanel, BorderLayout.NORTH);
		addFrame.add(areaScrollPane, BorderLayout.CENTER);

		// Luodaan painonapit
		buttonPanel = new JPanel();

		add_button = new JButton(Text.adddvdText);
		add_button.setActionCommand(Text.adddvdFormCommand);
		add_button.addActionListener(new ActionListener() {
			 public void actionPerformed(ActionEvent e) {
				 AddDvd();
			 }
		});		
		buttonPanel.add(add_button);
		exit_button = new JButton(Text.exitText);
		exit_button.setActionCommand(Text.exitFormCommand);
		exit_button.addActionListener(new ActionListener() {
			 public void actionPerformed(ActionEvent e) {
				addFrame.setVisible(false);
				addFrame.dispose();
				UpdateCenterPanel();
			 }
		});		
		buttonPanel.add(exit_button);
		addFrame.add(buttonPanel, BorderLayout.SOUTH);

		addFrame.setLocation(200, 200);
		addFrame.pack();
		addFrame.setVisible(true);
	}

	/*
	 * ModifyBook
	 * 
	 *
	 * Luodaan kirjan muokkaus -ikkuna
	 * 
	 */
	public void ModifyBook() {
		
		CreateModifyBookForm();
	}

		




	/*
	 * RemoveDvd
	 * 
	 * Luodaan DVD:n poisto -ikkuna
	 * 
	 */
	public boolean RemoveDvd(JFrame aFrame) {
		boolean choice=false;
		boolean result=false;
		
		Dvd dvd = dvdModel.getRowAt(curRowIndex);

		choice = RemoveDvdDialog(aFrame, dvd);
		
		if(true == choice) {
			result = sql.RemoveDvd(dvd);
		} else if(false == choice) {
			
		}
		return result;
	}
	
		/*
		 * RemoveDvd
		 * 
		 * Luodaan DVD:n poisto -ikkuna
		 * 
		 */
		public boolean RemoveBook(JFrame aFrame) {
			boolean choice=false;
			boolean result=false;
			
			Book book = bookModel.getRowAt(curRowIndex);

			choice = RemoveBookDialog(aFrame, book);
			
			if(true == choice) {
				result = sql.RemoveBook(book);
			} else if(false == choice) {
				
			}
			return result;

	}	/*
	 * Print
	 * 
	 * Tulosta kirjasto
	 * 
	 */
	public void Print() {
/*
		try {
			JTable table = GetBookTable(bookModel);

			boolean complete = table.print();
	        if (complete) {
				System.out.println("Printing was success.");
	        } else {
				System.out.println("Printing was ended.");
	        }
	    } catch (PrinterException pe) {
			System.out.println("Printing failed.");
	    }
*/
	}

	/*
	 * Exit
	 */
	public void Exit(JFrame aFrame) {

		sql.CloseConnection();
		aFrame.setVisible(false);
		aFrame.dispose();
	}


	/*
	 * 
	 */
	public String GetSearchText() {
		
		String searchtext = searchfield.getText();	
		return searchtext;	
	}


	/*
	 * GetBookCount
	 */
	public int GetBookCount() {
		
		return bookModel.getRowCount();
		}
	



	/*
	 * GetDvdCount
	 */
	public int GetDvdCount() {
		
		return dvdModel.getRowCount();
		}

	/*
	 * GetBookScrollPane
	 */
	public JScrollPane GetBookScrollPane() {
		
		return bookTableScrollPane;
		}
	
	/*
	 * GetDvdScrollPane
	 */
	public JScrollPane GetDvdScrollPane() {
		
		return dvdTableScrollPane;
		}

	/*
	 * GetTopPanel
	 */
	public JPanel GetTopPanel() {
		
		return topPanel;	
	}

	/*
	 * GetCenterPanel
	 */
	public JTabbedPane GetCenterPanel() {
		
		return centerPanel;	
	}
	
	/*
	 * ModifyBook
	 */
	public void ModifyBookGetValues(Book orgbook) {
		int pubdate,orgyear;
		boolean addResult = false;
		String[] fieldValue;
		String otherValue;
		
		try {	
			fieldValue = new String[LibraryBookModel.columns.length];
			fieldValue = GetBookAddFields();
			otherValue = GetOtherField();
			
			if (fieldValue[3].length() == 0) {
				pubdate = 0;
			} else {
				pubdate = Integer.parseInt(fieldValue[3]);
			}
			if (fieldValue[6].length() == 0) {
				orgyear = 0;
			} else {
				orgyear = Integer.parseInt(fieldValue[6]);
			}
			
			Book book = new Book(fieldValue[0],
						fieldValue[1],
						fieldValue[2],
						pubdate,
						fieldValue[4],
						fieldValue[5],
						orgyear,
						otherValue);

			addResult  = sql.ModifyBook(book, orgbook);

			if(addResult != false) {
				JOptionPane.showMessageDialog(addFrame, Text.modifybooksuccess, Text.addtitle, JOptionPane.INFORMATION_MESSAGE);
				} else {
				JOptionPane.showMessageDialog(addFrame, Text.modifybookfail, Text.addtitle, JOptionPane.ERROR_MESSAGE);
			}

			//SetBookAddFormFields("");
		} catch(NumberFormatException e) { 
			JOptionPane.showMessageDialog(addFrame, Text.intfail, Text.addtitle, JOptionPane.ERROR_MESSAGE); 
		} 
	}
	
	/*
	 * SetFrame
	 * 
	 * Tuodaan pääikkuna
	 * 
	 */	public void SetFrame(JFrame aFrame) {
		mainFrame = aFrame;
	}
	
	/*
	 * CreatePopupMenu
	 * 
	 * Luodaan popup-menu
	 * 
	 */
	private JPopupMenu CreatePopupMenu(Book aBook) {
		
		JPopupMenu popupMenu = new JPopupMenu();
		
		// Luodaan kirjan poisto valinta pop-up:in
		JMenuItem choice4 = new JMenuItem(Text.removebookText+" "+aBook.bookname);
		popupMenu.add(choice4);
		choice4.addActionListener(new ActionListener() {
			 public void actionPerformed(ActionEvent e) {
				 boolean result = RemoveBook(mainFrame);   
					if(true==result) {
						UpdateCenterPanel();
	            }
			 }
		});
		choice4.setActionCommand(Text.removebookCommand);
		
		// Luodaan kirjan muokkaus valinta pop-up:in
		JMenuItem choice5 = new JMenuItem(Text.modifybookText+" "+aBook.bookname);	
		popupMenu.add(choice5);		
		choice5.addActionListener(new ActionListener() {
			 public void actionPerformed(ActionEvent e) {
				 ModifyBook();
	            }
		});
		choice5.setActionCommand(Text.modifybookFormCommand);
		
		return popupMenu;
	}

    private void showPopup(MouseEvent e, JPopupMenu aPopupMenu) {
        if (e.isPopupTrigger()) {
        	aPopupMenu.show(e.getComponent(),
                    e.getX(), e.getY());
        }
    }
	/*
 * CreateBookScrollPane
 *
 * Luodaan taulukko joka sisältää kirjat
 * 
 */
	public void CreateBookScrollPane(LibraryBookModel model) {
	
		final JTable table = new JTable();
	    table.setPreferredScrollableViewportSize(new Dimension(bookFieldTotalLength,Text.tableHeight));
	    table.setFillsViewportHeight(true);
	    table.setAutoCreateRowSorter(true);
	    table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		table.setAutoCreateColumnsFromModel(false);
		table.setModel(model);
		for (int k = 0; k < LibraryBookModel.columns.length; k++) {
			TableRenderer renderer = new TableRenderer();
		    renderer.setHorizontalAlignment(LibraryBookModel.columns[k].alignment);
		    TableColumn column = new TableColumn(k, LibraryBookModel.columns[k].width, renderer, null);
		    column.setHeaderValue(LibraryBookModel.columns[k].title);
		    table.addColumn(column);   
		}
		table.setDefaultRenderer(Book.class, new TableRenderer());
		ListSelectionModel listSelectionModel = table.getSelectionModel();
	
	
		ListSelectionListener selectionListener = new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent event) {
				// Valitaan kirja taulukosta
				curRowIndex = table.getSelectedRow();
				selectedbook = bookModel.getRowAt(curRowIndex);
				
				// Luodaan popupmenu kirjalle
				popupMenu = CreatePopupMenu(selectedbook);
				
				System.out.println("Selected book : "+selectedbook.bookname);
				}
		};
		listSelectionModel.addListSelectionListener(selectionListener);
		table.setSelectionModel(listSelectionModel);
		bookTableScrollPane = new JScrollPane(table);	
	
		table.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent mouseEvent) {
				if (mouseEvent.getClickCount()==2) {
					System.out.println("Doubleclicked book : "+selectedbook.bookname);
					
					// Tuplaklikkauksella luodaan ikkuna jolla voidaan muokata kirjaa
					CreateModifyBookForm();
				}}
			public void mousePressed(MouseEvent mouseEvent) {
	            if (mouseEvent.getButton() == MouseEvent.BUTTON3) {
					System.out.println("Right clicked book : "+selectedbook.bookname);
					
					// Näytetään popup-menu kirjalle 
					showPopup(mouseEvent, popupMenu);
	            }}
	
			public void mouseReleased(MouseEvent mouseEvent) {
	            if (mouseEvent.getButton() == MouseEvent.BUTTON3) {
					System.out.println("Right clicked book : "+selectedbook.bookname);
	
					// Näytetään popup-menu kirjalle 
					showPopup(mouseEvent, popupMenu);
	            }}
	
			});
	}
	
	/*
	 * UpdateCenterPanel
	 */
	public void UpdateCenterPanelUI(JFrame aFrame) {
			aFrame.remove(GetBottomPanel());
			aFrame.add(GetBottomPanel(), BorderLayout.SOUTH);
			aFrame.pack();
			aFrame.validate();
			aFrame.repaint();
			}
/*
	 * UpdateBottomPanel
	 */
	public void UpdateBottomPanelUI(JFrame aFrame) {
		
		aFrame.remove(GetBottomPanel());
		aFrame.add(GetBottomPanel(), BorderLayout.SOUTH);
		aFrame.validate();
		aFrame.repaint();
	}

	

	
	/*
	 * CreateModifyBookForm
	 * 
	 *
	 * Luodaan kirjan muokkaus -ikkuna
	 * 
	 */
	public void CreateModifyBookForm() {
		
		JPanel formPanel, labelPanel, fieldPanel,buttonPanel;
		JScrollPane areaScrollPane;
		JButton add_button,exit_button;
		
		addFrame = new JFrame(Text.modifybookText);
		addFrame.setLayout(new BorderLayout());

		// Luodaan kirjan tietojen sy�tt�kent�t ja otsakkeet 
		formPanel = new JPanel(new BorderLayout());
		labelPanel = new JPanel(new GridLayout(Text.bookTablefieldNames.length-1, 1));
		fieldPanel = new JPanel(new GridLayout(Text.bookTablefieldNames.length-1, 1));

		formPanel.add(labelPanel, BorderLayout.WEST);
		formPanel.add(fieldPanel, BorderLayout.CENTER);

		fields = new JTextField[Text.bookTablefieldNames.length-1];

		for (int i = 0; i < Text.bookTablefieldNames.length-1; i++) {
			JLabel lab;
			JPanel p;
			
			fields[i] = new JTextField();
			if (i < Text.bookTablefieldNames.length-1)
				fields[i].setColumns(30);
				switch (i) {
					
				case 0:
					fields[i].setText(selectedbook.surname);
					break;
				case 1:
					fields[i].setText(selectedbook.forename);
					break;
				case 2:
					fields[i].setText(selectedbook.bookname);
					break;
				case 3:
					fields[i].setText(String.valueOf(selectedbook.pubyear));
					break;
				case 4:
					fields[i].setText(selectedbook.isbn);
					break;
				case 5:
					fields[i].setText(selectedbook.orgname);
					break;
				case 6:
					fields[i].setText(String.valueOf(selectedbook.orgyear));
					break;
				}

			lab = new JLabel(Text.bookTablefieldNames[i], JLabel.RIGHT);
			lab.setLabelFor(fields[i]);

			labelPanel.add(lab);
			p = new JPanel(new FlowLayout(FlowLayout.LEFT));
			p.add(fields[i]);
			fieldPanel.add(p);
		}

		// Luodaan muuta tietoa tekstikentt�
		textArea = new JTextArea();
		textArea.setLineWrap(true);
		textArea.setWrapStyleWord(true);
		areaScrollPane = new JScrollPane(textArea);
		areaScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		areaScrollPane.setPreferredSize(new Dimension(250, 100));
		areaScrollPane.setBorder(BorderFactory.createCompoundBorder(
				BorderFactory.createCompoundBorder(BorderFactory
						.createTitledBorder(Text.bookTablefieldNames[7]), BorderFactory
						.createEmptyBorder(5, 5, 5, 5)), areaScrollPane
						.getBorder()));
		textArea.setText(selectedbook.other);
		
		addFrame.add(formPanel, BorderLayout.NORTH);
		addFrame.add(areaScrollPane, BorderLayout.CENTER);

		// Luodaan painonapit
		buttonPanel = new JPanel();

		add_button = new JButton(Text.modifybookText);
		add_button.setActionCommand(Text.modifybookFormCommand);
		add_button.addActionListener(new ActionListener() {
			 public void actionPerformed(ActionEvent e) {
				 ModifyBookGetValues(selectedbook);
			 }
		});		
		buttonPanel.add(add_button);
		exit_button = new JButton(Text.exitText);
		exit_button.setActionCommand(Text.exitFormCommand);
		exit_button.addActionListener(new ActionListener() {
			 public void actionPerformed(ActionEvent e) {
				addFrame.setVisible(false);
				addFrame.dispose();
				UpdateCenterPanel();
			 }
		});		
		buttonPanel.add(exit_button);
		addFrame.add(buttonPanel, BorderLayout.SOUTH);

		addFrame.setLocation(200, 200);
		addFrame.pack();
		addFrame.setVisible(true);
	}
	
	

	/*
	 * RemoveBook
	 * 
	 * Luodaan kirjan poisto -ikkuna
	 * 
	 */
	public boolean RemoveBookDialog(JFrame aFrame, Book aBook) {
		boolean choice=false;
		
		int remove = CreateOptionDialog(aFrame, Text.bookremove1+" '"+aBook.bookname+"' "+Text.bookremove2, Text.removebookText);
		
		if(JOptionPane.NO_OPTION == remove) {
			
		} else if(JOptionPane.YES_OPTION == remove) {
			choice = true;
		}
		return choice;
	}

	/*
	 * RemoveDvd
	 * 
	 * Luodaan DVD:n poisto -ikkuna
	 * 
	 */
	public boolean RemoveDvdDialog(JFrame aFrame, Dvd aDVD) {
		boolean choice=false;
		
		int remove = CreateOptionDialog(aFrame, Text.dvdremove1+" '"+aDVD.name+"' "+Text.dvdremove2, Text.removedvdText);
		
		if(JOptionPane.NO_OPTION == remove) {
			
		} else if(JOptionPane.YES_OPTION == remove) {
			choice = true;
		}
		return choice;
	}
	

	
	/*
	 * CreateMessageDialog
	 */
	public void CreateMessageDialog(JFrame aFrame, String aMessage, String aTitle, int aType) {
		JOptionPane.showMessageDialog(aFrame, aMessage, aTitle, JOptionPane.INFORMATION_MESSAGE);
		}

	/*
	 * CreateOptionDialog
	 */
	public int CreateOptionDialog(JFrame aFrame, String aMessage, String aTitle) {
		
		int result = JOptionPane.showOptionDialog(aFrame, 
				aMessage, 
				aTitle, 
				JOptionPane.YES_NO_OPTION,
				JOptionPane.WARNING_MESSAGE,
				null,
				options,
				options[0]);
		
		return result;
		}


	/*
	 * SetBookAddFormFields
	 */
	public void SetBookAddFormFields(String aString) {
	
		for (int i = 0; i < Text.bookTablefieldNames.length-1; i++) {
			fields[i].setText(aString);
		}
		textArea.setText(aString);
	}

	/*
	 * SetDvdAddFormFields
	 */
	public void SetDvdAddFormFields(String aString) {
	
		for (int i = 0; i < Text.dvdTablefieldNames.length-1; i++) {
			fields[i].setText(aString);
		}
		textArea.setText(aString);
	}

	
	/*
	 * GetBottomPanel
	 */
	public JPanel GetBottomPanel() {
		
		return bottomPanel;	
	}

	
	/*
	 * GetOtherField
	 */
	public String GetOtherField() {
		
		return textArea.getText();	
	}

	/*
	 * GetDvdAddFields
	 */
	public String[] GetDvdAddFields() {
		String[] text;
		
		text = new String[Text.dvdTablefieldNames.length-1];
		for (int k = 0; k < Text.dvdTablefieldNames.length-1; k++) {
			text[k] = fields[k].getText();
			}
		
		return text;	
	}

	
	/*
	 * GetBookAddFields
	 */
	public String[] GetBookAddFields() {
		String[] text;
		
		text = new String[Text.bookTablefieldNames.length-1];
		for (int k = 0; k < Text.bookTablefieldNames.length-1; k++) {
			text[k] = fields[k].getText();
			}
		
		return text;	
	}

	/*
	 * GetSql
	 */
	public SqlHandler GetSql() {
		return sql;
	}

	/*
	 * GetXml
	 */
	public XmlHandler GetXml() {
		return xml;
	}
/*
	public Book GetSelectedBook() {
		
		return selectedbook;
	}
	*/
}

/**
 * @author fiinmani
 *
 */
final class TableRenderer extends DefaultTableCellRenderer {
	private static final long serialVersionUID = 1L;

	/*
	 * setValue
	 */
	public void setValue(Object aValue) {
		    
		  Object result = aValue;
		    
		  if ( aValue != null ) {
		  
		  	  setToolTipText( aValue.toString() );
		    } 
		  super.setValue(result);
	}   

}


/**
 * @author fiinmani
 *
 */
final class XmlFilter extends FileFilter {

	/*
	 * accept
	 */
    public boolean accept(File f) {
    	
        if (f.isDirectory()) {
            return true;
        }

        String extension = FileUtils.getExtension(f);
        if (extension != null) {
            if (extension.equals(FileUtils.xml)) {
                    return true;
            } else {
                return false;
            }
        }

        return false;
    }

	/*
	 * getDescription
	 */
    public String getDescription() {
        return "XML files";
    }
}

/**
 * @author fiinmani
 *
 */
final class FileUtils {
    public final static String xml = "xml";

	/*
	 * getExtension
	 */
    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }

}

