/**
 * 
 */
package library;

import java.io.File;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Result;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * @author fiinmani
 *
 */
public class XmlHandler {

	/*
	 * 
	 */
	public XmlHandler() {

	}
	
	/*
	 * 
	 */
	public void Export(LibraryBookModel book, LibraryDvdModel dvd, String aFile) throws Exception {
		
	    DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
	    DocumentBuilder builder = factory.newDocumentBuilder();
	    DOMImplementation impl = builder.getDOMImplementation();
	    Document doc = impl.createDocument(null, null, null);
	    
	    Element library = doc.createElement(Text.elementLibrary); 
	    doc.appendChild(library);                    

	    for (int i =0; i < book.getRowCount(); i++) {

	    	Element bookElement = doc.createElement(Text.elementBook);
	        
	        for (int j = 0; j < book.getColumnCount(); j++) {
				Element element;
				Node node;
				
				element = doc.createElement(Text.bookDatafieldNames[j]);
				if (book.getValueAt(i, j) != null) {
					node = doc.createTextNode(book.getValueAt(i, j).toString());
					element.appendChild(node);
				}
				bookElement.appendChild(element);	
	        }
	        library.appendChild(bookElement);
	    }

	    for (int i =0; i < dvd.getRowCount(); i++) {

	    	Element dvdElement = doc.createElement(Text.elementDvd);
	        
	        for (int j = 0; j < dvd.getColumnCount(); j++) {
				Element element;
				Node node;
				
				element = doc.createElement(Text.dvdDatafieldNames[j]);
				if (dvd.getValueAt(i, j) != null) {
					node = doc.createTextNode(dvd.getValueAt(i, j).toString());
					element.appendChild(node);
				}
				dvdElement.appendChild(element);	
	        }
	        library.appendChild(dvdElement);
	    }

	    DOMSource domSource = new DOMSource(doc);
	    Transformer transformer = TransformerFactory.newInstance().newTransformer();
	    transformer.setOutputProperty(OutputKeys.INDENT, "yes");
	    Result result = new StreamResult(new File(aFile));   
	    transformer.transform(domSource, result);
	}

	/*
	 * 
	 */
	public void Import(Utils aUtils,String aFilename) throws Exception {
		Vector<Book> bookVector = new Vector<Book>();
		Vector<Dvd> dvdVector = new Vector<Dvd>();
		
		try {
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			Document doc = db.parse(aFilename);
			doc.getDocumentElement().normalize();

			if (doc.getDocumentElement().getNodeName().compareTo(Text.elementLibrary) == 0) {

				NodeList bookList = doc.getElementsByTagName(Text.elementBook);
 
				for (int s = 0; s < bookList.getLength(); s++) {

					Node bookNode = bookList.item(s);
					    
					if (bookNode.getNodeType() == Node.ELEMENT_NODE) {
						int length = Text.bookDatafieldNames.length;
						String[] data = new String[length];
						
						for (int i = 0; i < length; i++) {
							
							NodeList fstNmElmntLst = ((Element) bookNode).getElementsByTagName(Text.bookDatafieldNames[i]);
						    Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
						    NodeList fstNm = fstNmElmnt.getChildNodes();
						    try {
						    	Node node = (Node) fstNm.item(0);
							    if (node != null) {
							    	data[i] = node.getNodeValue();
							    } else {
							    	data[i] = "";
							    }
						    } catch (Exception e) {
								  e.printStackTrace();
						    }
						}
					    
					    bookVector.addElement(new Book(data[0],
					    							   data[1],
					    							   data[2],
					    							   Integer.parseInt(data[3]),
					    							   data[4],
					    							   data[5],
					    							   Integer.parseInt(data[6]),
					    							   data[7]));
				    }	
				}

				NodeList dvdList = doc.getElementsByTagName(Text.elementDvd);

				for (int s = 0; s < dvdList.getLength(); s++) {

					Node dvdNode = dvdList.item(s);
					    
					if (dvdNode.getNodeType() == Node.ELEMENT_NODE) {
						int length = Text.dvdDatafieldNames.length;
						String[] data = new String[length];
						
						for (int i = 0; i < length; i++) {
							
							NodeList fstNmElmntLst = ((Element) dvdNode).getElementsByTagName(Text.dvdDatafieldNames[i]);
						    Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
						    NodeList fstNm = fstNmElmnt.getChildNodes();
						    try {
						    	Node node = (Node) fstNm.item(0);
							    if (node != null) {
							    	data[i] = node.getNodeValue();
							    } else {
							    	data[i] = "";
							    }
						    } catch (Exception e) {
								  e.printStackTrace();
						    }
						}
					    
						dvdVector.addElement(new Dvd(data[0],
   							 						 Integer.parseInt(data[1]),
   							 						 data[2],
   							 						 data[3],
   							 						 data[4],
   							 						 data[5],
   							 						 data[6]));
				    }	
				}
			} else {
				System.out.println("Import failed.");
			}
		  } catch (Exception e) {
			  e.printStackTrace();
		  }
		  
		LibraryBookModel bookModel = new LibraryBookModel(bookVector);
		LibraryDvdModel dvdModel = new LibraryDvdModel(dvdVector);
		
        for (int i=0; i < bookModel.getRowCount(); i++) {
			
			aUtils.GetSql().AddBook(bookModel.getRowAt(i));
		}
        for (int i=0; i < dvdModel.getRowCount(); i++) {
			
        	aUtils.GetSql().AddDvd(dvdModel.getRowAt(i));
		}
	}

}
